#############################################################################
##
#W  core_methods.gd  Most common structural methods [quandles]
##
#H  @(#)$Id: core_methods.gd, v 2.1.3 2011/02/17 gap Exp $
##
#Y  Copyright (C)  2004,  G. P. Nagy (University of Szeged, Hungary),
#Y                        P. Vojtechovsky (University of Denver, USA)
##

#############################################################################
##  GENERATORS
##  -------------------------------------------------------------------------

DeclareSynonymAttr( "GeneratorsOfRack", GeneratorsOfMagma );
DeclareSynonymAttr( "GeneratorsOfQuandle", GeneratorsOfRack );
# attribute GeneratorsSmallest already declared for groups

#############################################################################
##  SECTIONS
##  -------------------------------------------------------------------------

DeclareAttribute( "LeftSection", IsRack );
DeclareOperation( "LeftTranslation",
    [ IsRack, IsRackElement ] );



#############################################################################
##  MULTIPLICATION GROUPS
##  -------------------------------------------------------------------------

DeclareAttribute( "LeftMultiplicationGroup", IsRack );
DeclareOperation( "RelativeLeftMultiplicationGroup",
    [ IsRack, IsRack ] );
DeclareAttribute( "DisplacementGroup", IsRack );


#############################################################################
##  SUBQUASIGROUPS AND SUBLOOPS
##  -------------------------------------------------------------------------

DeclareOperation( "PosInParent", [ IsCollection ] );
# Position already declared in GAP
DeclareOperation( "SubrackNC", [ IsRack, IsSet ] );
DeclareOperation( "Subrack", [ IsRack, IsList ] );
DeclareSynonym( "Subquandle", Subrack );
DeclareOperation( "IsSubrack", [ IsRack, IsRack ] );
DeclareOperation( "IsSubquandle", [ IsQuandle, IsQuandle ] );
#DeclareOperation( "AllSubloops", [ IsLoop ] );
# RightCosets already declared in GAP
#DeclareOperation( "RightTransversal", [ IsLoop, IsLoop ] );

#DeclareOperation( "FixedPoints", [IsGroup, IsMapping] );




################################################################################
##   AFFINE MESHES
##  ---------------------------------------------------------------------------

DeclareOperation( "AffineMeshesOfGroups",  [ IsList ]);
DeclareOperation( "AllHomomorphismsIncludingTrivial", [ IsGroup, IsGroup ]);
DeclareOperation( "AllEndomorphismsIncludingTrivial", [ IsGroup ]);
DeclareOperation( "AffineMeshSupports" , [ IsInt,IsBool ]);
DeclareOperation( "IsomorphismAffineMeshes", [ IsAffineMesh, IsAffineMesh ]);
DeclareOperation( "AffineMeshesIsomorphismClasses", [ IsList ]);
DeclareOperation( "AffineMeshesOfSize", [IsInt]);
DeclareOperation( "InvolutoryAffineMeshesOfSize", [IsInt]);
DeclareOperation( "InvolutoryAffineMeshesOfGroups",  [ IsList ]);

DeclareOperation ("WriteMeshesToFile",[IsString,IsList]);
